diff --git a/Documentation/devicetree/bindings/opp/qcom-cpufreq-nvmem.yaml b/Documentation/devicetree/bindings/opp/qcom-cpufreq-nvmem.yaml
index 4a7d4826746e..338781c63ba6 100644
--- a/Documentation/devicetree/bindings/opp/qcom-cpufreq-nvmem.yaml
+++ b/Documentation/devicetree/bindings/opp/qcom-cpufreq-nvmem.yaml
@@ -13,11 +13,11 @@ description: |
   In Certain Qualcomm Technologies, Inc. SoCs like apq8096 and msm8996,
   the CPU frequencies subset and voltage value of each OPP varies based on
   the silicon variant in use.
-  Qualcomm Technologies, Inc. Process Voltage Scaling Tables
-  defines the voltage and frequency value based on the msm-id in SMEM
-  and speedbin blown in the efuse combination.
-  The qcom-cpufreq-nvmem driver reads the msm-id and efuse value from the SoC
-  to provide the OPP framework with required information (existing HW bitmap).
+  Qualcomm Technologies, Inc. Process Voltage Scaling Tables defines
+  the voltage and frequency value based on the speedbin blown in the
+  efuse combination.
+  The qcom-cpufreq-nvmem driver reads the efuse value from the SoC to provide
+  the OPP framework with required information (existing HW bitmap).
   This is used to determine the voltage and frequency value for each OPP of
   operating-points-v2 table when it is parsed by the OPP framework.
 
@@ -60,14 +60,10 @@ patternProperties:
             description: |
               A single 32 bit bitmap value, representing compatible HW.
               Bitmap:
-              0:  MSM8996 V3, speedbin 0
-              1:  MSM8996 V3, speedbin 1
-              2:  MSM8996 V3, speedbin 2
-              3:  unused
-              4:  MSM8996 SG, speedbin 0
-              5:  MSM8996 SG, speedbin 1
-              6:  MSM8996 SG, speedbin 2
-              7-31:  unused
+              0:  MSM8996, speedbin 0
+              1:  MSM8996, speedbin 1
+              2:  MSM8996, speedbin 2
+              3-31:  unused
 
         required:
           - opp-hz
@@ -212,206 +208,82 @@ examples:
 
             opp-307200000 {
                 opp-hz = /bits/ 64 <307200000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x77>;
-                clock-latency-ns = <200000>;
-            };
-            opp-384000000 {
-                opp-hz = /bits/ 64 <384000000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-422400000 {
                 opp-hz = /bits/ 64 <422400000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-460800000 {
-                opp-hz = /bits/ 64 <460800000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-480000000 {
                 opp-hz = /bits/ 64 <480000000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-537600000 {
-                opp-hz = /bits/ 64 <537600000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-556800000 {
                 opp-hz = /bits/ 64 <556800000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-614400000 {
-                opp-hz = /bits/ 64 <614400000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-652800000 {
                 opp-hz = /bits/ 64 <652800000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-691200000 {
-                opp-hz = /bits/ 64 <691200000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-729600000 {
                 opp-hz = /bits/ 64 <729600000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-768000000 {
-                opp-hz = /bits/ 64 <768000000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-844800000 {
                 opp-hz = /bits/ 64 <844800000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x77>;
-                clock-latency-ns = <200000>;
-            };
-            opp-902400000 {
-                opp-hz = /bits/ 64 <902400000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-960000000 {
                 opp-hz = /bits/ 64 <960000000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-979200000 {
-                opp-hz = /bits/ 64 <979200000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1036800000 {
                 opp-hz = /bits/ 64 <1036800000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1056000000 {
-                opp-hz = /bits/ 64 <1056000000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1113600000 {
                 opp-hz = /bits/ 64 <1113600000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1132800000 {
-                opp-hz = /bits/ 64 <1132800000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1190400000 {
                 opp-hz = /bits/ 64 <1190400000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1209600000 {
-                opp-hz = /bits/ 64 <1209600000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1228800000 {
                 opp-hz = /bits/ 64 <1228800000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1286400000 {
-                opp-hz = /bits/ 64 <1286400000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1324800000 {
                 opp-hz = /bits/ 64 <1324800000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x5>;
-                clock-latency-ns = <200000>;
-            };
-            opp-1363200000 {
-                opp-hz = /bits/ 64 <1363200000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x72>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-1401600000 {
                 opp-hz = /bits/ 64 <1401600000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x5>;
-                clock-latency-ns = <200000>;
-            };
-            opp-1440000000 {
-                opp-hz = /bits/ 64 <1440000000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-1478400000 {
                 opp-hz = /bits/ 64 <1478400000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x1>;
-                clock-latency-ns = <200000>;
-            };
-            opp-1497600000 {
-                opp-hz = /bits/ 64 <1497600000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x4>;
-                clock-latency-ns = <200000>;
-            };
-            opp-1516800000 {
-                opp-hz = /bits/ 64 <1516800000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-1593600000 {
                 opp-hz = /bits/ 64 <1593600000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x71>;
-                clock-latency-ns = <200000>;
-            };
-            opp-1996800000 {
-                opp-hz = /bits/ 64 <1996800000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x20>;
-                clock-latency-ns = <200000>;
-            };
-            opp-2188800000 {
-                opp-hz = /bits/ 64 <2188800000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x10>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
         };
@@ -423,323 +295,131 @@ examples:
 
             opp-307200000 {
                 opp-hz = /bits/ 64 <307200000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x77>;
-                clock-latency-ns = <200000>;
-            };
-            opp-384000000 {
-                opp-hz = /bits/ 64 <384000000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-403200000 {
                 opp-hz = /bits/ 64 <403200000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-460800000 {
-                opp-hz = /bits/ 64 <460800000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-480000000 {
                 opp-hz = /bits/ 64 <480000000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-537600000 {
-                opp-hz = /bits/ 64 <537600000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-556800000 {
                 opp-hz = /bits/ 64 <556800000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-614400000 {
-                opp-hz = /bits/ 64 <614400000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-652800000 {
                 opp-hz = /bits/ 64 <652800000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-691200000 {
-                opp-hz = /bits/ 64 <691200000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-729600000 {
                 opp-hz = /bits/ 64 <729600000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-748800000 {
-                opp-hz = /bits/ 64 <748800000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-806400000 {
                 opp-hz = /bits/ 64 <806400000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-825600000 {
-                opp-hz = /bits/ 64 <825600000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-883200000 {
                 opp-hz = /bits/ 64 <883200000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-902400000 {
-                opp-hz = /bits/ 64 <902400000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-940800000 {
                 opp-hz = /bits/ 64 <940800000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-979200000 {
-                opp-hz = /bits/ 64 <979200000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1036800000 {
                 opp-hz = /bits/ 64 <1036800000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1056000000 {
-                opp-hz = /bits/ 64 <1056000000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1113600000 {
                 opp-hz = /bits/ 64 <1113600000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1132800000 {
-                opp-hz = /bits/ 64 <1132800000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1190400000 {
                 opp-hz = /bits/ 64 <1190400000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1209600000 {
-                opp-hz = /bits/ 64 <1209600000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1248000000 {
                 opp-hz = /bits/ 64 <1248000000>;
-                opp-microvolt = <905000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1286400000 {
-                opp-hz = /bits/ 64 <1286400000>;
-                opp-microvolt = <905000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1324800000 {
                 opp-hz = /bits/ 64 <1324800000>;
-                opp-microvolt = <1140000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1363200000 {
-                opp-hz = /bits/ 64 <1363200000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1401600000 {
                 opp-hz = /bits/ 64 <1401600000>;
-                opp-microvolt = <1140000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1440000000 {
-                opp-hz = /bits/ 64 <1440000000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1478400000 {
                 opp-hz = /bits/ 64 <1478400000>;
-                opp-microvolt = <1140000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1516800000 {
-                opp-hz = /bits/ 64 <1516800000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1555200000 {
                 opp-hz = /bits/ 64 <1555200000>;
-                opp-microvolt = <1140000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1593600000 {
-                opp-hz = /bits/ 64 <1593600000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1632000000 {
                 opp-hz = /bits/ 64 <1632000000>;
-                opp-microvolt = <1140000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1670400000 {
-                opp-hz = /bits/ 64 <1670400000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1708800000 {
                 opp-hz = /bits/ 64 <1708800000>;
-                opp-microvolt = <1140000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1747200000 {
-                opp-hz = /bits/ 64 <1747200000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x70>;
-                clock-latency-ns = <200000>;
-            };
             opp-1785600000 {
                 opp-hz = /bits/ 64 <1785600000>;
-                opp-microvolt = <1140000 905000 1140000>;
                 opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
-            opp-1804800000 {
-                opp-hz = /bits/ 64 <1804800000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x6>;
-                clock-latency-ns = <200000>;
-            };
             opp-1824000000 {
                 opp-hz = /bits/ 64 <1824000000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x71>;
-                clock-latency-ns = <200000>;
-            };
-            opp-1900800000 {
-                opp-hz = /bits/ 64 <1900800000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x74>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-1920000000 {
                 opp-hz = /bits/ 64 <1920000000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x1>;
-                clock-latency-ns = <200000>;
-            };
-            opp-1977600000 {
-                opp-hz = /bits/ 64 <1977600000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x30>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-1996800000 {
                 opp-hz = /bits/ 64 <1996800000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x1>;
-                clock-latency-ns = <200000>;
-            };
-            opp-2054400000 {
-                opp-hz = /bits/ 64 <2054400000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x30>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-2073600000 {
                 opp-hz = /bits/ 64 <2073600000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x1>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
             opp-2150400000 {
                 opp-hz = /bits/ 64 <2150400000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x31>;
-                clock-latency-ns = <200000>;
-            };
-            opp-2246400000 {
-                opp-hz = /bits/ 64 <2246400000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x10>;
-                clock-latency-ns = <200000>;
-            };
-            opp-2342400000 {
-                opp-hz = /bits/ 64 <2342400000>;
-                opp-microvolt = <1140000 905000 1140000>;
-                opp-supported-hw = <0x10>;
+                opp-supported-hw = <0x7>;
                 clock-latency-ns = <200000>;
             };
         };
 
-        reserved-memory {
-            #address-cells = <2>;
-            #size-cells = <2>;
-            ranges;
-
-            smem_mem: smem-mem@86000000 {
-                reg = <0x0 0x86000000 0x0 0x200000>;
-                no-map;
-            };
-        };
-
-        smem {
-            compatible = "qcom,smem";
-            memory-region = <&smem_mem>;
-            hwlocks = <&tcsr_mutex 3>;
-        };
-
         soc {
             #address-cells = <1>;
             #size-cells = <1>;